#!/usr/bin/wish
#Source WikSpeak Program 
#Version 1.1
#Tested on Linux (Mandrake 10.1) and Windows 98
#GNU License 
#Fonts for x11
#http://www.cl.cam.ac.uk/~mgk25/ucs-fonts.html 

set copy_before "default"
set copy_last "default"
set word_last ""
set url ""
set idx1 -2
set idx2 -3

set pathinst [pwd]

lappend auto_path "$pathinst/snack2.2"



package require Tk

package require http
#proxy server support
set cfg_proxy [open "cfgproxy.txt" r]
gets $cfg_proxy hostname
gets $cfg_proxy port
close $cfg_proxy
puts $hostname
puts $port
::http::config -proxyhost $hostname -proxyport $port -useragent "Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.14) Gecko/20080404 Firefox/2.0.0.14"
# proxy server support end

package require snack
package require snackogg


toplevel .wabout
wm title .wabout "About..."
wm resizable .wabout 0 0
label .wabout.labout1 -background white -relief solid -font  "doulos 15" -text "WikSpeak version 1.1"
label .wabout.labout2 -background white -font "doulos 10" -width 4 -text "http://wikspeak.sourceforge.net"
label .wabout.labout3 -background white -relief groove -font "doulos 10" -text "Program starting..."

switch [tk windowingsystem] {
x11 {
#if {[catch { ::tk::pkgconfig get fontsystem } xft]} {
#set xft no-xft
#puts "no support"
#}
set pathinst [pwd]
wm iconbitmap . @$pathinst/icons/wkicon.xbm
wm iconbitmap .wabout @$pathinst/icons/wkicon.xbm

#Embedded fonts for X11
exec mkfontdir $pathinst/fonts/ucs-fonts
exec xset fp rehash

entry .ent -textvariable word -font "doulos 20 bold" -exportselection true -justify left 
entry .out -textvariable ipa_variable -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -state readonly -exportselection true  -cursor hand2


button .but3 -text "Enter" -font "courier 15 bold" -command "push_ipa" -height 1 -width 4 
button .but -text "Chart" -font "courier 15 bold" -command "ch" -height 1 -width 4
checkbutton .mode1 -text "Sound" -font "courier 15 bold" -command "push_sound" -variable "check_sound" -onvalue 1 -offvalue 0
checkbutton .mode2 -text "Auto" -font "courier 15 bold" -command "auto " -variable "check_auto" -onvalue 1 -offvalue 0
set ipa_view [menu .popup_ipa -tearoff 0]
$ipa_view add command -label ""
bind .out <ButtonRelease-1> {
.popup_ipa unpost 
}
}

win32 {
#console show
set pathinst [pwd]
lappend auto_path "$pathinst/Ffidl0.6"
package require Ffidl

 ffidl::callout dll_SHGetSpecialFolderPath \
   {int pointer-utf16 int int} int \
   [ffidl::symbol shell32.dll SHGetSpecialFolderPathW]

 proc SHGetSpecialFolderPath {what create} {
   array set CSIDL {
     
     CSIDL_FONTS                   20
     
   }

   set bCreat [expr {$create ? 1 : 0}]

   set path [string repeat \u0000 300] ;# MAX_PATH is actually 260

   set ok [dll_SHGetSpecialFolderPath 0 $path $CSIDL($what) $bCreat]

   if {$ok} {
     set ix [string first \u0000 $path]
     if {$ix > 0} {
       return [string range $path 0 [expr {$ix - 1}]]
     }
   } else {
     return {}
   }
 }

 puts "appdata: [SHGetSpecialFolderPath CSIDL_FONTS false]"
##Embedded fonts for Windows
if {![file exists $pathinst/fonts/DoulosSIL4.0.14.r1/DoulosSILR.ttf]} {
file copy $pathinst/fonts/DoulosSIL4.0.14.r1/DoulosSILR.ttf [SHGetSpecialFolderPath CSIDL_FONTS false]
}


wm iconbitmap . $pathinst/icons/wkicon.ico
wm iconbitmap .wabout $pathinst/icons/wkicon.ico
entry .ent -textvariable word -font "doulos 15 bold" -exportselection true -justify left
entry .out -textvariable ipa_variable -font "doulos 15 bold" -state readonly -exportselection true  -cursor hand2
button .but3 -text "Enter" -font "courier 10 bold" -command "push_ipa" -height 1 -width 5
button .but -text "Chart" -font "courier 10 bold" -command "ch" -height 1 -width 5
checkbutton .mode1 -text "Sound" -font "courier 10 bold" -command "push_sound" -variable "check_sound" -onvalue 1 -offvalue 0
checkbutton .mode2 -text "Auto" -font "courier 10 bold" -command "auto " -variable "check_auto" -onvalue 1 -offvalue 0

bind .out <ButtonRelease-1> {
destroy .popup_ipa 
}

}
default {
puts "Window System not implemented"
exit
}
}

grid .ent .out .but .but3 .mode1 .mode2 
grid configure .ent  -row 0 -column 0 -columnspan 3
grid configure .out  -row 1 -column 0 -columnspan 3
grid configure .but3  -row 2 -column 0 -rowspan 2
grid configure .mode1 -row 2 -column 1 -stick w
grid configure .mode2  -row 3 -column 1 -stick w
grid configure .but -row 2 -column 2 -rowspan 2


wm title . "WikSpeak" 
wm resizable . 0 0

update
wm geometry . +[expr {[winfo screenwidth .]-[winfo width .] - 50}]+50
wm geometry .wabout [winfo width .]x[winfo height .]+[expr {[winfo screenwidth .]-[winfo width .] - 50}]+50
pack configure .wabout.labout1 .wabout.labout2  .wabout.labout3 -expand 1 -fill both
update

puts [ .out cget -font ] 
if { [lindex [ .out cget -font ] 0] ne "doulos" && [ .out cget -font ]  ne "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" } {
tk_messageBox -message "The program can't install embedded fonts, IPA symbols couldn't be displayed correctly" -type ok
}
#---- ----

#Key Return
bind .ent <Key> {
set keysym "%K"
#puts "$keysym"
if {[string match $keysym "Return"] ==1 } {
push_ipa
}
}

#  Clicks on IPA symbols
bind .wabout <Button-1> {
after cancel $id
destroy .wabout
wm deiconify .
}


wm withdraw .
wm deiconify .wabout
if { [winfo exists .wabout] == 1} {
set id [after 5000 destroy .wabout  ]
after 5000 wm deiconify .
update
}



bind .out <ButtonPress-1> {

# Detecting the IPA symbol was clicked
for {set ipa_index 0} {$ipa_index < [string length $ipa_variable]} {incr ipa_index} {
if  {[lindex [.out bbox $ipa_index ] 0] <= (%x) && [expr {[lindex [ .out bbox $ipa_index ] 0] +  [lindex [ .out bbox $ipa_index ] 2]}]> (%x) } {

# IPA symbols composed by individual IPA symbols 
set ipa_group 0
set ipa_pairs [string range $ipa_variable $ipa_index [expr { $ipa_index +1}]]
if {[string match $ipa_pairs "\u0069\u02d0"] || [string match $ipa_pairs u\u02d0] || [string match $ipa_pairs \u0251\u02d0] || [string match $ipa_pairs \u0254\u02d0] || [string match $ipa_pairs \u025C\u02d0] ||  [string match $ipa_pairs "\u026A\u0259"] ||  [string match $ipa_pairs "\u028A\u0259"] ||  [string match $ipa_pairs "a\u026A"] ||  [string match $ipa_pairs "\u0254\u026A"]  ||  [string match $ipa_pairs "\u0259\u028A"] ||  [string match $ipa_pairs "e\u0259"] ||  [string match $ipa_pairs "a\u028A"] ||  [string match $ipa_pairs "e\u026A"]  || [string match $ipa_pairs "d\u0292" ] || [string match $ipa_pairs "t\u0283" ]}  { 
 set ipa_group 1
 }
 
 set ipa_pairs [string range $ipa_variable [expr { $ipa_index -1}] $ipa_index]
if {[string match $ipa_pairs "\u0069\u02d0"] || [string match $ipa_pairs u\u02d0] || [string match $ipa_pairs \u0251\u02d0] || [string match $ipa_pairs \u0254\u02d0] || [string match $ipa_pairs \u025C\u02d0] ||  [string match $ipa_pairs "\u026A\u0259"] ||  [string match $ipa_pairs "\u028A\u0259"] ||  [string match $ipa_pairs "a\u026A"] ||  [string match $ipa_pairs "\u0254\u026A"]  ||  [string match $ipa_pairs "\u0259\u028A"] ||  [string match $ipa_pairs "e\u0259"] ||  [string match $ipa_pairs "a\u028A"] ||  [string match $ipa_pairs "e\u026A"]  || [string match $ipa_pairs "d\u0292" ] || [string match $ipa_pairs "t\u0283" ] }  {
 set ipa_group 2
}

set ipa_pairs [string range $ipa_variable [expr {$ipa_index - 2}] $ipa_index]
if { [string match "a\u026a\u0259"  $ipa_pairs] || [string match "\u0254\u026a\u0259"  $ipa_pairs] || [string match "a\u028a\u0259"  $ipa_pairs] || [string match "\u0259\u028a\u0259"  $ipa_pairs] || [string match "e\u026A\u0259"  $ipa_pairs]} {
set ipa_group 0
} 

#Showing the IPA symbol in a pop-up menu 
switch [tk windowingsystem] {
x11 {
switch $ipa_group { 
 0 {
 
 $ipa_view entryconfigure 1 -label  " [string index [.out get] $ipa_index ]" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646-1 20 bold"
 switch [string index $ipa_variable $ipa_index] {
 "\u02c8"  {
 $ipa_view entryconfigure 1 -label "Primary stress"
 set ipa_play "silent"
 }
 "\u02cc" {
 $ipa_view entryconfigure 1 -label "Secondary stress"
 set ipa_play "silent"
 puts [winfo ismapped .popup_ipa]
 }
 
 default {
 $ipa_view entryconfigure 1 -label  " [string index [.out get] $ipa_index ]" -font "doulos 20 bold"
 set ipa_play [string index [.out get] $ipa_index ]
 }
 }
 
 }
 1 {
 $ipa_view entryconfigure 1 -label  " [string range [.out get] $ipa_index [expr {$ipa_index + 1}] ]" -font "doulos 20 bold"
 set ipa_play [string range [.out get] $ipa_index [expr {$ipa_index + 1}] ]
 }
 2 {
 $ipa_view entryconfigure 1 -label  " [string range [.out get]  [expr {$ipa_index - 1}] $ipa_index ]" -font "doulos 20 bold"
 set ipa_play [string range [.out get]  [expr {$ipa_index - 1}] $ipa_index ]
 }

 }
 }
 
 win32 {
 if {[winfo exists .popup_ipa] == 0 } {
 set ipa_view [menu .popup_ipa -tearoff 0]
 $ipa_view add command -label ""
 grab release .popup_ipa
 }
 switch $ipa_group { 
 0 {
 switch [string index $ipa_variable $ipa_index] {
 "\u02c8"  {
 $ipa_view entryconfigure 1 -label "Primary stress" -font "doulos 10 bold"
 set ipa_play "silent"
  }
 "\u02cc" {
 $ipa_view entryconfigure 1 -label "Secondary stress" -font "doulos 10 bold"
 set ipa_play "silent"
 }
 default {
 $ipa_view entryconfigure 1 -label  "[string index [.out get] $ipa_index ]" -font "doulos 15 bold"
 set ipa_play [string index [.out get] $ipa_index ]
 }
 }
 }
 1 {
 $ipa_view entryconfigure 1 -label  "[string range [.out get] $ipa_index [expr {$ipa_index + 1}] ]" -font "doulos 15 bold"
 set ipa_play [string range [.out get] $ipa_index [expr {$ipa_index + 1}] ]
 }
 2 {
 $ipa_view entryconfigure 1 -label  "[string range [.out get]  [expr {$ipa_index - 1}] $ipa_index ]" -font "doulos 15 bold"
 set ipa_play [string range [.out get]  [expr {$ipa_index - 1}] $ipa_index ]
 }
 
 
 }
 }
 }
 
 #Playing the phoneme for the IPA symbol 
 switch $ipa_play {
 \u026a {
 push_1 
 }
 \u028A {
 push_2
 }
 \u028C {
 push_3
 }
 \u0252 {
 push_4
 }
 \u0259 {
 push_5
 }
 e {
 push_6
 }
 \u00E6 {
 push_7
 }
 i\u02d0 {
 push_8
 }
 u\u02d0 {
 push_9
 }
 \u0251\u02d0 {
 push_10
 }
 \u0254\u02d0 {
 push_11
 }
 \u025c\u02d0 {
 push_12
 }
 \u026A\u0259 {
 push_37
 }
 \u028A\u0259 {
 push_38
 }
 a\u026A {
 push_39
 }
 \u0254\u026A {
 push_40
 }
 \u0259\u028A {
 push_41
 }
 e\u0259 {
 push_42
 }
 a\u028A {
 push_43
 }
 e\u026A {
 push_44
 }
 p {
 push_13
 }
 t {
 push_14
 }
 \u02A7 {
 push_15
 }
 k {
 push_16
 }
 f {
 push_17
 }
 \u03B8 {
 push_18
 }
 s {
 push_19
 }
 \u0283 {
 push_20
 }
 b {
 push_21
 }
 d {
 push_22
 }
 \u02A4 {
 push_23
 }
 g {
 push_24
 }
 v {
 push_25
 }
 \u00F0 {
 push_26
 }
 z {
 push_27
 }
 \u0292 {
 push_28
 }
 m {
 push_29
 }
 n {
 push_30
 }
 \u014B {
 push_31
 }
 h {
 push_32
 }
 l {
 push_33
 }
 r {
 push_34
 }
 w {
 push_35
 }
 j {
 push_36
 }
 default {
 push_silent
 }
 }

.popup_ipa post  %X %Y 

}
}
}



proc translate {} {
global ipa_variable

set pathinst [pwd]
set word [.ent get]

set infile [open "$pathinst/transcriptions/dictchar" r]

#Index for faster transcription look up

switch [string range $word 0 0] {

a {
seek $infile 73568  start
}
b {
seek $infile 141741 start
}
c {
seek $infile 209669 start
}
d {
seek $infile 337636 start
}
e {
seek $infile 425476 start
}
f {
seek $infile 478459 start
}
g {
seek $infile 532869 start
}
h {
seek $infile 570471 start
}
i {
seek $infile 611864 start
}
j {
seek $infile 673641 start
}
k {
seek $infile 683838 start
}
l {
seek $infile 690563 start
}
m {
seek $infile 729000 start
}
n {
seek $infile 793668 start
}
o {
seek $infile 815011 start 
}
p {
seek $infile 850672 start
}
q {
seek $infile 963674 start 
}
r {
seek $infile 970727 start
}
s {
seek $infile 1046826 start
}
t {
seek $infile 1204169 start
}
u {
seek $infile 1270118 start
}
v {
seek $infile 1307258 start
}
w {
seek $infile 1325037 start
}
x { 
seek $infile 1359071 start
}
y {
seek $infile 1359157 start
}
z {
seek $infile 1361774 start

}
}

while { [gets $infile line] >= 0 } {

set ew [string range $line 0 [expr [string first ";" $line ] - 1]]

if {[string match $word $ew] == 1 } {

set rcp [string range $line [expr [string first ";" $line ] + 1] end]

# Char to IPA mapping
set ipa_variable [string map {\u0026 \u00e6 \u0069 \u0069\u02d0 \u0049 \u026a \u0075 \u0075\u02d0 \u0056 \u028c \u0041 \u0251\u02d0 \u0030 \u0252 \u004f \u0254\u02d0 \u0055 \u028a \u0033 \u025c\u02d0 \u0040 \u0259 \u006f\u0049 \u0254\u026a \u0040\u0055 \u0259\u028a \u004e \u014b \u0053 \u0283 \u0054 \u03b8 \u005a \u0292 \u0044 \u00f0 \u0052 \u0072 \u0027 \u02c8 \u005c\u002e \u02cc "tS" \u02A7 "dZ" \u02A4} $rcp]

# "aI" "\u0251\u026A" "aU" "\u0251\u028A"
break
} 
} 
if { [string match $word $ew] == 0 } {
tk_messageBox -message "No phonetic transcription for $word" -type ok
}
close $infile

}


proc get_audio_file_link { line keyword } { 
global infile
global pathinst
global word
global audio_file
if { [regexp $keyword $line ] == 1 } {
set id_base [string first $keyword $line]
set id_det1 [string first "dxt" $line $id_base]
set id_det2 [string first "<" $line $id_det1]
set r_word [string map { "dxt\u0022>" "" "<" "" } [string range $line $id_det1 $id_det2]]


puts "word_r $r_word"
puts "$keyword"

close $infile
set infile [open "$pathinst/mw.html" w]
set query_sound "http://www.learnersdictionary.com/search/$r_word"
set token2 [::http::geturl  $query_sound -timeout 25000 -channel $infile]
close $infile
set infile [open "mw.html" r]

while { [gets $infile line] >= 0 } {
#if { [regexp "No entries found that match" $line] == 1 } {
#tk_messageBox -message "No sound for $word on Merriam Webster's" -type ok
#append ipa_variable " no Sound"
#return
#}


if { [regexp "playAudio" $line ] == 1 } {

#set audio_file http://media.merriam-webster.com/soundc11/t/$pronounce_file
set idx [string first playAudio $line]
set id1 [string first "(" $line $idx]  
set id2 [string first "," $line $id1]
set id3 [string first ")" $line $id2]  
set audio_file_name [string map {, "" ' "" ( "" \u0020 ""} [string range $line $id1 $id2]]
set word_look_up [string map {, "" ' "" ) "" \u0020 "" * ""} [string range $line $id2 $id3]]
puts $word_look_up
puts "audio $audio_file_name"
if { $word_look_up eq $word } {
set first_letter [string index $audio_file_name 0]
set audio_file "http://media.merriam-webster.com/soundc11/$first_letter/$audio_file_name"
break
}

set idx [string first playAudio $line]
set id1 [string first "(" $line $id3]  
set id2 [string first "," $line $id1]
set id3 [string first ")" $line $id2]  
set audio_file_name [string map {, "" ' "" ( "" \u0020 ""} [string range $line $id1 $id2]]
set word_look_up [string map {, "" ' "" ) "" \u0020 "" * ""} [string range $line $id2 $id3]]
puts $word_look_up
puts "audio $audio_file_name"
if { $word_look_up eq $word } {
set first_letter [string index $audio_file_name 0]
set audio_file "http://media.merriam-webster.com/soundc11/$first_letter/$audio_file_name"
break
}

set idx [string first playAudio $line]
set id1 [string first "(" $line $id3]  
set id2 [string first "," $line $id1]
set id3 [string first ")" $line $id2]  
set audio_file_name [string map {, "" ' "" ( "" \u0020 ""} [string range $line $id1 $id2]]
set word_look_up [string map {, "" ' "" ) "" \u0020 "" * ""} [string range $line $id2 $id3]]
puts $word_look_up
puts "audio $audio_file_name"
if { $word_look_up eq $word } {
set first_letter [string index $audio_file_name 0]
set audio_file "http://media.merriam-webster.com/soundc11/$first_letter/$audio_file_name"
break
}

}
}



} else {
return
}
}

proc push_sound {} {
global check_sound
global ipa_variable
global url
global infile
global audio_file
set word [string trim [.ent get] "\x00"]
set word [string map { ' ""} $word]
set pathinst [pwd]
set audio_file "x_0_x"
set ipa_variable_backup $ipa_variable

set cache_sounds [file exist "$pathinst/sounds/$word.wav"]

if { $cache_sounds == 0} {
#puts "sound web"
set idx 0
set idxe 0


set pathinst [pwd]

set ipa_variable "Wait, downloanding..."
update
set infile [open "$pathinst/mw.html" w]
set query_sound "http://www.learnersdictionary.com/search/$word"
set token2 [::http::geturl  $query_sound -timeout 25000 -channel $infile]

upvar #0 $token2 state
if { $state(status) == "timeout"} {
 tk_messageBox -message "MW website temporarily inaccessible" -type ok
 return
 }
 
close $infile


set flag1 0
set flag2 0
set n 0
set flag0 0

set infile [open "mw.html" r]
while { [gets $infile line] >= 0 } {


get_audio_file_link $line "past tense of"

get_audio_file_link $line "plural of"

get_audio_file_link $line "past participle of"

get_audio_file_link $line "past tense and past participle of"

get_audio_file_link $line "past tense and past participle tense of"


if { [regexp "Pronounced" $line ] == 1 } {
set r_word $word
if { [regexp "playAudio" $line ] == 1 } {

set idx [string first playAudio $line]
set id1 [string first "(" $line $idx]  
set id2 [string first "," $line $id1]
set id3 [string first ")" $line $id2]  
set audio_file_name [string map {, "" ' "" ( "" \u0020 ""} [string range $line $id1 $id2]]
set word_look_up [string map {, "" ' "" ) "" \u0020 "" * ""} [string range $line $id2 $id3]]
puts $word_look_up
puts "audio1 $audio_file_name"
if { [string match -nocase $word_look_up $word] } {
set first_letter [string index $audio_file_name 0]
set audio_file "http://media.merriam-webster.com/soundc11/$first_letter/$audio_file_name"
puts "root"
break
}


set idx [string first playAudio $line]
set id1 [string first "(" $line $id3]  
set id2 [string first "," $line $id1]
set id3 [string first ")" $line $id2]  
set audio_file_name [string map {, "" ' "" ( "" \u0020 ""} [string range $line $id1 $id2]]
set word_look_up [string map {, "" ' "" ) "" \u0020 "" * ""} [string range $line $id2 $id3]]
puts $word_look_up
puts "audio $audio_file_name"
if { $word_look_up eq $word } {
set first_letter [string index $audio_file_name 0]
set audio_file "http://media.merriam-webster.com/soundc11/$first_letter/$audio_file_name"
break
}

set idx [string first playAudio $line]
set id1 [string first "(" $line $id3]  
set id2 [string first "," $line $id1]
set id3 [string first ")" $line $id2]  
set audio_file_name [string map {, "" ' "" ( "" \u0020 ""} [string range $line $id1 $id2]]
set word_look_up [string map {, "" ' "" ) "" \u0020 "" * ""} [string range $line $id2 $id3]]
puts $word_look_up
puts "audio $audio_file_name"
if { $word_look_up eq $word } {
set first_letter [string index $audio_file_name 0]
set audio_file "http://media.merriam-webster.com/soundc11/$first_letter/$audio_file_name"
break
}


}
}




}






close $infile

if  {$audio_file == "x_0_x"} {

if  { [string range $word end-2 end] == "ing" } {
tk_messageBox -message "No sound for '$word', the closer word is '[string range $word 0 end-3]'" -type ok
set ipa_variable $ipa_variable_backup
return
}

if  { [string range $word end-1 end] == "ed" } {
tk_messageBox -message "No sound for '$word', the closer word is '[string range $word 0 end-2]'" -type ok
set ipa_variable $ipa_variable_backup
return
}

if  { [string range $word end-2 end] == "est" } {
tk_messageBox -message "No sound for '$word', the closer word is '[string range $word 0 end-3]'" -type ok
set ipa_variable $ipa_variable_backup
return
}

if  { [string range $word end-1 end] == "er" } {
tk_messageBox -message "No sound for '$word', the closer word is '$word_look_up'" -type ok
set ipa_variable $ipa_variable_backup
return
}

if  { [string range $word end end] == "s" } {
tk_messageBox -message "No sound for '$word', the closer word is '$word_look_up'" -type ok
set ipa_variable $ipa_variable_backup
return
}
tk_messageBox -message "No sound for '$word'" -type ok
set ipa_variable $ipa_variable_backup
return

} else {

set infile [open "$pathinst/sounds/$word.wav" w]
::http::geturl $audio_file -channel $infile
close $infile
 }
 
 } else {
# puts "sound cache"
 }

set ipa_variable $ipa_variable_backup
snack::sound s1 -load "$pathinst/sounds/$word.wav"

s1 play

return

}

proc push_ipa {} {
  global word
  global check_sound
  global word_last
  global ipa_variable
  set word  [.ent get]
  #set word [string trim  [string tolower $word 0 [string length $word]] "\x00"]
  #if {[string match $word $word_last] ==0} {
 # puts "new entry"
  translate
  #}
  if {  $check_sound == 1 } {
  push_sound
  }
  set word_last $word

  }
  
proc automatic { } {  
global copy_before
global copy_last
global check_sound
if {[catch {clipboard get}] == 0} {
set copy_last [clipboard get] 
set copy_last_1 [split [string tolower $copy_last 0 [string length $copy_last]]]
set copy_last [string trim [lindex $copy_last_1 0] "\x00"]

clipboard clear
clipboard append $copy_last 
if { [string match $copy_last $copy_before] == 0} {
set copy_before $copy_last
.ent delete 0 [string length  [.ent get]] 
#.ent insert end [clipboard get]

.ent insert end $copy_last
translate
if {  $check_sound == 1 } {
push_sound
}
}
}  
}

proc auto { } {

global check_auto
global copy_before
global copy_last

update
automatic
if { $check_auto == 1 } {
clipboard clear
after 1000 auto

} else {
after cancel auto

}

}

proc ch {} {

if { [winfo exists .wc] == 1} {
return
}

toplevel .wc

wm title .wc "IPA Chart for English"
wm resizable .wc 0 0
 
 global pathinst
 set pathinst [pwd]

switch [tk windowingsystem] {
 x11 {
wm iconbitmap .wc @$pathinst/icons/wkicon.xbm


label .wc.l1 -text "Vowels"
label .wc.l2 -text "short"
button .wc.b1 -text "\u026A" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_1" -height 1 -width 2
button .wc.b2 -text "\u028A" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_2" -height 1 -width 2
button .wc.b3 -text "\u028C" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_3" -height 1 -width 2
button .wc.b4 -text "\u0252" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_4" -height 1 -width 2
button .wc.b5 -text "\u0259" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_5" -height 1 -width 2
button .wc.b6 -text "e" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_6" -height 1 -width 2
button .wc.b7 -text "\u00E6" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_7" -height 1 -width 2

#Long Vowels
label .wc.l3 -text "long"
button .wc.b8 -text "i\u02d0" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_8" -height 1 -width 2
button .wc.b9 -text "u\u02d0" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_9" -height 1 -width 2
button .wc.b10 -text "\u0251\u02d0" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_10" -height 1 -width 2
button .wc.b11 -text "\u0254\u02d0" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_11" -height 1 -width 2
button .wc.b12 -text "\u025C\u02d0" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_12" -height 1 -width 2

#Diphthongs
label .wc.l4 -text "Diphthongs"
button .wc.b37 -text "\u026A\u0259" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_37" -height 1 -width 2
button .wc.b38 -text "\u028A\u0259" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_38" -height 1 -width 2
button .wc.b39 -text "a\u026A" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_39" -height 1 -width 2
button .wc.b40 -text "\u0254\u026A" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_40" -height 1 -width 2
button .wc.b41 -text "\u0259\u028A" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_41" -height 1 -width 2
button .wc.b42 -text "e\u0259" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_42" -height 1 -width 2
button .wc.b43 -text "a\u028A" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_43" -height 1 -width 2
button .wc.b44 -text "e\u026A" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_44" -height 1 -width 2


#Consonants
label .wc.l5 -text "Consonants"
button .wc.b13 -text "p" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_13" -height 1 -width 2
button .wc.b14 -text "t" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_14" -height 1 -width 2
button .wc.b15 -text "\u02A7" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_15" -height 1 -width 2
button .wc.b16 -text "k" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_16" -height 1 -width 2
button .wc.b17 -text "f" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_17" -height 1 -width 2
button .wc.b18 -text "\u03B8" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_18" -height 1 -width 2
button .wc.b19 -text "s" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_19" -height 1 -width 2
button .wc.b20 -text "\u0283" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_20" -height 1 -width 2
button .wc.b21 -text "b" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_21" -height 1 -width 2
button .wc.b22 -text "d" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_22" -height 1 -width 2
button .wc.b23 -text "\u02A4" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_23" -height 1 -width 2
button .wc.b24 -text "g" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_24" -height 1 -width 2
button .wc.b25 -text "v" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_25" -height 1 -width 2
button .wc.b26 -text "\u00F0" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_26" -height 1 -width 2
button .wc.b27 -text "z" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_27" -height 1 -width 2
button .wc.b28 -text "\u0292" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_28" -height 1 -width 2
button .wc.b29 -text "m" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_29" -height 1 -width 2
button .wc.b30 -text "n" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_30" -height 1 -width 2
button .wc.b31 -text "\u014B" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_31" -height 1 -width 2
button .wc.b32 -text "h" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_32" -height 1 -width 2
button .wc.b33 -text "\u026D" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_33" -height 1 -width 2
button .wc.b34 -text "r" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_34" -height 1 -width 2
button .wc.b35 -text "w" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_35" -height 1 -width 2
button .wc.b36 -text "j" -font "-Misc-Fixed-Medium-R-Normal--20-200-75-75-C-100-ISO10646" -command "push_36" -height 1 -width 2
button .wc.b45 -text "Close Chart" -command "destroy .wc" -height 1 -width 10


}
win32 {


wm iconbitmap .wc $pathinst/icons/wkicon.ico

label .wc.l1 -text "Vowels"
label .wc.l2 -text "short"
button .wc.b1 -text "\u026A" -font "doulos 15 bold" -command "push_1" -height 1 -width 2
button .wc.b2 -text "\u028A" -font "doulos 15 bold" -command "push_2" -height 1 -width 2
button .wc.b3 -text "\u028C" -font "doulos 15 bold" -command "push_3" -height 1 -width 2
button .wc.b4 -text "\u0252" -font "doulos 15 bold" -command "push_4" -height 1 -width 2
button .wc.b5 -text "\u0259" -font "doulos 15 bold" -command "push_5" -height 1 -width 2
button .wc.b6 -text "e" -font "doulos 15 bold" -command "push_6" -height 1 -width 2
button .wc.b7 -text "\u00E6" -font "doulos 15 bold" -command "push_7" -height 1 -width 2

#Long Vowels
label .wc.l3 -text "long"
button .wc.b8 -text "i\u02d0" -font "doulos 15 bold" -command "push_8" -height 1 -width 2
button .wc.b9 -text "u\u02d0" -font "doulos 15 bold" -command "push_9" -height 1 -width 2
button .wc.b10 -text "\u0251\u02d0" -font "doulos 15 bold" -command "push_10" -height 1 -width 2
button .wc.b11 -text "\u0254\u02d0" -font "doulos 15 bold" -command "push_11" -height 1 -width 2
button .wc.b12 -text "\u025C\u02d0" -font "doulos 15 bold" -command "push_12" -height 1 -width 2

#Diphthongs
label .wc.l4 -text "Diphthongs"
button .wc.b37 -text "\u026A\u0259" -font "doulos 15 bold" -command "push_37" -height 1 -width 2
button .wc.b38 -text "\u028A\u0259" -font "doulos 15 bold" -command "push_38" -height 1 -width 2
button .wc.b39 -text "a\u026A" -font "doulos 15 bold" -command "push_39" -height 1 -width 2
button .wc.b40 -text "\u0254\u026A" -font "doulos 15 bold" -command "push_40" -height 1 -width 2
button .wc.b41 -text "\u0259\u028A" -font "doulos 15 bold" -command "push_41" -height 1 -width 2
button .wc.b42 -text "e\u0259" -font "doulos 15 bold" -command "push_42" -height 1 -width 2
button .wc.b43 -text "a\u028A" -font "doulos 15 bold" -command "push_43" -height 1 -width 2
button .wc.b44 -text "e\u026A" -font "doulos 15 bold" -command "push_44" -height 1 -width 2


#Consonants
label .wc.l5 -text "Consonants"
button .wc.b13 -text "p" -font "doulos 15 bold" -command "push_13" -height 1 -width 2
button .wc.b14 -text "t" -font "doulos 15 bold" -command "push_14" -height 1 -width 2
button .wc.b15 -text "\u02A7" -font "doulos 15 bold" -command "push_15" -height 1 -width 2
button .wc.b16 -text "k" -font "doulos 15 bold" -command "push_16" -height 1 -width 2
button .wc.b17 -text "f" -font "doulos 15 bold" -command "push_17" -height 1 -width 2
button .wc.b18 -text "\u03B8" -font "doulos 15 bold" -command "push_18" -height 1 -width 2
button .wc.b19 -text "s" -font "doulos 15 bold" -command "push_19" -height 1 -width 2
button .wc.b20 -text "\u0283" -font "doulos 15 bold" -command "push_20" -height 1 -width 2
button .wc.b21 -text "b" -font "doulos 15 bold" -command "push_21" -height 1 -width 2
button .wc.b22 -text "d" -font "doulos 15 bold" -command "push_22" -height 1 -width 2
button .wc.b23 -text "\u02A4" -font "doulos 15 bold" -command "push_23" -height 1 -width 2
button .wc.b24 -text "g" -font "doulos 15 bold" -command "push_24" -height 1 -width 2
button .wc.b25 -text "v" -font "doulos 15 bold" -command "push_25" -height 1 -width 2
button .wc.b26 -text "\u00F0" -font "doulos 15 bold" -command "push_26" -height 1 -width 2
button .wc.b27 -text "z" -font "doulos 15 bold" -command "push_27" -height 1 -width 2
button .wc.b28 -text "\u0292" -font "doulos 15 bold" -command "push_28" -height 1 -width 2
button .wc.b29 -text "m" -font "doulos 15 bold" -command "push_29" -height 1 -width 2
button .wc.b30 -text "n" -font "doulos 15 bold" -command "push_30" -height 1 -width 2
button .wc.b31 -text "\u014B" -font "doulos 15 bold" -command "push_31" -height 1 -width 2
button .wc.b32 -text "h" -font "doulos 15 bold" -command "push_32" -height 1 -width 2
button .wc.b33 -text "\u026D" -font "doulos 15 bold" -command "push_33" -height 1 -width 2
button .wc.b34 -text "r" -font "doulos 15 bold" -command "push_34" -height 1 -width 2
button .wc.b35 -text "w" -font "doulos 15 bold" -command "push_35" -height 1 -width 2
button .wc.b36 -text "j" -font "doulos 15 bold" -command "push_36" -height 1 -width 2
button .wc.b45 -text "Close Chart" -command "destroy .wc" -height 2 -width 10

}
default {
puts "Windows System not implemented"
}
}

grid  .wc.b1 .wc.b2 .wc.b3 .wc.b4 .wc.b5 .wc.b6 .wc.b7 .wc.b8 .wc.b9 .wc.b10 .wc.b11 .wc.b12 .wc.b13 .wc.b14 .wc.b15 .wc.b17 .wc.b18 .wc.b19 .wc.b20 .wc.b21 .wc.b22 .wc.b23 .wc.b24 .wc.b25 .wc.b26 .wc.b27 .wc.b28 .wc.b29 .wc.b30 .wc.b31 .wc.b32 .wc.b33 .wc.b34 .wc.b35 .wc.b36 .wc.b37 .wc.b38 .wc.b39 .wc.b40 .wc.b41 .wc.b42 .wc.b43 .wc.b44 .wc.b45 .wc.l1 .wc.l2 .wc.l3 .wc.l4 .wc.l5

grid configure .wc.l1 -row 0 -column 2 -columnspan 3
grid configure .wc.l2 -row 2 -column 7 

grid configure .wc.b1 -row 2 -column 0 
grid configure .wc.b2 -row 2 -column 1 
grid configure .wc.b3 -row 2 -column 2
grid configure .wc.b4 -row 2 -column 3
grid configure .wc.b5 -row 2 -column 4
grid configure .wc.b6 -row 2 -column 5 
grid configure .wc.b7 -row 2 -column 6

grid configure .wc.l3 -row 4 -column 5 

grid configure .wc.b8 -row 4 -column 0 
grid configure .wc.b9 -row 4 -column 1
grid configure .wc.b10 -row 4  -column 2
grid configure .wc.b11 -row 4  -column 3
grid configure .wc.b12 -row 4 -column 4

grid configure .wc.l5 -row 7 -column 2 -columnspan 3

grid configure .wc.b13 -row 8 -column 0
grid configure .wc.b14 -row 8 -column 1
grid configure .wc.b15 -row 8 -column 2
grid configure .wc.b16 -row 8 -column 3
grid configure .wc.b17 -row 8 -column 4
grid configure .wc.b18 -row 8 -column 5 
grid configure .wc.b19 -row 8 -column 6
grid configure .wc.b20 -row 8 -column 7

grid configure .wc.b21 -row 9 -column 0
grid configure .wc.b22 -row 9 -column 1
grid configure .wc.b23 -row 9 -column 2
grid configure .wc.b24 -row 9 -column 3
grid configure .wc.b25 -row 9 -column 4
grid configure .wc.b26 -row 9 -column 5 
grid configure .wc.b27 -row 9 -column 6
grid configure .wc.b28 -row 9 -column 7

grid configure .wc.b29 -row 10 -column 0
grid configure .wc.b30 -row 10 -column 1
grid configure .wc.b31 -row 10 -column 2
grid configure .wc.b32 -row 10 -column 3
grid configure .wc.b33 -row 10 -column 4
grid configure .wc.b34 -row 10 -column 5 
grid configure .wc.b35 -row 10 -column 6
grid configure .wc.b36 -row 10 -column 7

grid configure .wc.l4 -row 5 -column 2 -columnspan 3

grid configure .wc.b37 -row 6 -column 0
grid configure .wc.b38 -row 6 -column 1
grid configure .wc.b39 -row 6 -column 2
grid configure .wc.b40 -row 6 -column 3
grid configure .wc.b41 -row 6 -column 4
grid configure .wc.b42 -row 6 -column 5 
grid configure .wc.b43 -row 6 -column 6
grid configure .wc.b44 -row 6 -column 7


grid configure .wc.b45 -row 4 -column 6 -columnspan 3

}

proc push_1 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/01.ogg"
s1 play
}
proc push_2 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/02.ogg"
s1 play
}
proc push_3 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/03.ogg"
s1 play
}
proc push_4 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/04.ogg"
s1 play
}
proc push_5 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/05.ogg"
s1 play
}
proc push_6 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/06.ogg"
s1 play
}
proc push_7 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/07.ogg"
s1 play
}
proc push_8 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/08.ogg"
s1 play
}
proc push_9 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/09.ogg"
s1 play
}
proc push_10 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/10.ogg"
s1 play
}
proc push_11 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/11.ogg"
s1 play
}
proc push_12 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/12.ogg"
s1 play
}

proc push_37 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/13.ogg"
s1 play
}
proc push_38 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/15.ogg"
s1 play
}
proc push_39 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/16.ogg"
s1 play
}
proc push_40 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/17.ogg"
s1 play
}
proc push_41 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/18.ogg"
s1 play
}
proc push_42 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/19.ogg"
s1 play
}
proc push_43 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/20.ogg"
s1 play
}
proc push_44 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/21.ogg"
s1 play
}
proc push_13 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/22.ogg"
s1 play
}
proc push_14 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/23.ogg"
s1 play
}
proc push_15 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/24.ogg"
s1 play
}
proc push_16 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/25.ogg"
s1 play
}
proc push_17 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/26.ogg"
s1 play
}
proc push_18 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/27.ogg"
s1 play
}
proc push_19 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/28.ogg"
s1 play
}
proc push_20 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/29.ogg"
s1 play
}
proc push_21 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/30.ogg"
s1 play
}
proc push_22 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/31.ogg"
s1 play
}
proc push_23 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/32.ogg"
s1 play
}
proc push_24 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/33.ogg"
s1 play
}
proc push_25 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/34.ogg"
s1 play
}
proc push_26 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/35.ogg"
s1 play
}
proc push_27 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/36.ogg"
s1 play
}
proc push_28 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/37.ogg"
s1 play
}
proc push_29 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/38.ogg"
s1 play
}
proc push_30 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/39.ogg"
s1 play
}
proc push_31 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/40.ogg"
s1 play
}
proc push_32 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/41.ogg"
s1 play
}
proc push_33 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/42.ogg"
s1 play
}
proc push_34 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/43.ogg"
s1 play
}
proc push_35 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/44.ogg"
s1 play
}
proc push_36 { } {
global pathinst
snack::sound s1 -load "$pathinst/phonemes/45.ogg"
s1 play
}
proc push_silent {} {
}

if { [string match [tk windowingsystem] "win32"] } {
ch
destroy .wc
}
